/*
 * Copyright (c) 2009 by syntevo GmbH. All Rights Reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *  o Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 *  o Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 *  o Neither the name of syntevo GmbH nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package com.syntevo.openapi.gui;

import javax.swing.*;

import com.syntevo.openapi.gui.editor.*;

/**
 * This class manages automatic mnemonic generation.
 * First optain a reference of the MnemonicManager by calling {@link GuiComponentFactory#createMnemonicManager()},
 * then add all buttons (using {@link MnemonicManager#add(AbstractButton)}) or editors (using {@link Editor#addToMnemonicManager(MnemonicManager)} )
 * and finally invoke {@link MnemonicManager#setMnemonics()}.
 * On Mac OS&nbsp;X no mnemonics are set.
 * @deprecated
 */
public interface MnemonicManager {

	/**
	 * Adds the specified button to MnemonicManager.
	 *
	 * @param button to add
	 */
	void add(AbstractButton button);

	/**
	 * Actually 'calculates' and sets the mnemonics to the added components.
	 * Call this methods after you have added all components to the
	 * MnemonicManager.
	 */
	void setMnemonics();
}
