package com.syntevo.plugin.quickupdate;

import java.awt.*;
import java.util.*;
import javax.swing.*;

import org.tmatesoft.svn.core.*;

import com.syntevo.openapi.gui.dialog.*;
import com.syntevo.openapi.smartsvn.command.*;
import com.syntevo.openapi.smartsvn.command.update.*;
import com.syntevo.openapi.smartsvn.file.*;
import com.syntevo.openapi.smartsvn.settings.*;

/**
 * @author syntevo GmbH
 */
final class QuickUpdateWorkflow implements IUpdateWorkflow {

	// Fields =================================================================

	private final IUpdateWorkflow baseWorkflow;
	private final SettingsProvider settingsProvider;

	// Setup ==================================================================

	public QuickUpdateWorkflow(IUpdateWorkflow baseWorkflow, SettingsProvider settingsProvider) {
		this.baseWorkflow = baseWorkflow;
		this.settingsProvider = settingsProvider;
	}

	// Implemented ============================================================

	public void initialize(Set<Path> paths, boolean directoryMode, UpdateConfiguration configuration) {
		baseWorkflow.initialize(paths, directoryMode, configuration);
	}

	public boolean hasConfigurationPhase() {
		return UpdateSettings.isShowUpdateDialog(settingsProvider);
	}

	public JComponent createConfigurationComponent(Container parent) {
		return baseWorkflow.createConfigurationComponent(parent);
	}

	public JComponent getConfigurationFocusableComponent() {
		return baseWorkflow.getConfigurationFocusableComponent();
	}

	public void getConfiguration(UpdateConfiguration configuration) throws DialogValidationFailedException {
		baseWorkflow.getConfiguration(configuration);
	}

	public Set<UpdateEntry> preCommand(Set<UpdateEntry> updateEntries, SvnClients svnClients) throws SVNException {
		return baseWorkflow.preCommand(updateEntries, svnClients);
	}

	public void postCommand(Map pathToEvent, SvnClients svnClients) throws SVNException {
		baseWorkflow.postCommand(pathToEvent, svnClients);
	}
}
