package com.syntevo.plugin.sendsupportemail;

import com.syntevo.openapi.*;
import com.syntevo.openapi.log.*;
import com.syntevo.openapi.smartsvn.*;
import com.syntevo.openapi.smartsvn.action.*;
import com.syntevo.openapi.smartsvn.gui.menu.*;

/**
 * @author syntevo GmbH
 */
public final class SendSupportEmailPlugin implements IActivator, IActionProvider {

	// Constants ==============================================================

	public static final String ID = "com.syntevo.sendSupportEmail";
	public static final Logger LOG = LoggerFactory.createLogger(ID);

	// Implemented ============================================================

	public void initialize(SmartSvnServices services) {
		services.addProjectActionProvider(this);
	}

	public void modifyMenuBar(MenuContainer menuContainer) {
		final boolean inserted = MenuUtils.insertActionAfter(ProjectActionIds.HELP_CONTENT, SendSupportEmailAction.ID, null, "Contact Support", "Opens your e-mail client to send an e-mail to the SmartSVN support team.", false, false, menuContainer);
		if (!inserted) {
			LOG.error("menu item not found");
		}
	}

	public void createActions(ActionRegisterService service) {
		service.registerAction(SendSupportEmailAction.ID, new SendSupportEmailAction());
	}
}
